#import "WordArrayController.h"

NSString *WordMovedRowsType = @"WORD_MOVED_ROWS_TYPE";

@implementation WordArrayController

- (void)awakeFromNib {
	//hbOEhbv̐ݒ
    [_wordTableView registerForDraggedTypes:
	[NSArray arrayWithObjects:WordMovedRowsType, nil]];
}

/*
// ̊֐𗘗p͐Ȃ
- (BOOL)tableView:(NSTableView *)tableView writeRows:(NSArray *)rows
	toPasteboard:(NSPasteboard *)pboard {
    NSArray *typesArray = [NSArray arrayWithObjects:WordMovedRowsType, nil];

	[pboard declareTypes:typesArray owner:self];
    [pboard setPropertyList:rows forType:WordMovedRowsType];

	return YES;
}
*/
- (BOOL)tableView:(NSTableView *)tv writeRowsWithIndexes:(NSIndexSet *)rowIndexes toPasteboard:(NSPasteboard*)pboard
{
    NSArray *typesArray = [NSArray arrayWithObjects:WordMovedRowsType, nil];
	NSArray *rows;

	rows = [NSArray arrayWithObject:[NSNumber numberWithUnsignedInt:[rowIndexes firstIndex]]];	

	// rowIndexesnƃG[ôrows蒼Ă
	// ɗǂ@Ǝv܂
	[pboard declareTypes:typesArray owner:self];
    [pboard setPropertyList:rows forType:WordMovedRowsType];
	
	return YES;

}

- (NSDragOperation)tableView:(NSTableView *)tableView validateDrop:(id <NSDraggingInfo>)info 
	proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation {
    
    NSDragOperation dragOperation = NSDragOperationCopy;
  
    if ([info draggingSource] == _wordTableView) {
		dragOperation =  NSDragOperationMove;
    }

    [tableView setDropRow:row dropOperation:NSTableViewDropAbove];
	
    return dragOperation;
}

- (BOOL)tableView:(NSTableView *)tableView acceptDrop:(id <NSDraggingInfo>)info 
	row:(int)row dropOperation:(NSTableViewDropOperation)operation {
	NSArray *rows;
	int originRow;
	id object;
    NSArray *objects;

	objects = [self arrangedObjects];

	rows = [[info draggingPasteboard] propertyListForType:WordMovedRowsType];

	// ̍s
//	originRow = [[rows objectAtIndex:0] intValue];	
	originRow = [[rows objectAtIndex:0] unsignedIntValue];

	// e[u̍s̓ւ
    if ([info draggingSource] == _wordTableView) {
		object = [objects objectAtIndex:originRow];
		if (originRow > row) {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row];
		} else {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row-1];
		}

	}
	
	[_document updateChangeCount:NSChangeDone];

	return YES;
}

#pragma mark -
#pragma mark === NSTableView ====

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectTableColumn:(NSTableColumn *)aTableColumn {
	return NO;
}

- (BOOL)tableView:(NSTableView *)aTableView shouldEditTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex {
	[_document updateChangeCount:NSChangeDone];
	return YES;
}

@end
